/*
 * Copyright 2017 ObjectBox Ltd. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package io.objectbox.test.proguard;


import io.objectbox.BoxStore;
import io.objectbox.Cursor;
import io.objectbox.Transaction;
import io.objectbox.annotation.apihint.Internal;
import io.objectbox.internal.CursorFactory;

// THIS CODE IS GENERATED BY ObjectBox, DO NOT EDIT.

/**
 * ObjectBox generated Cursor implementation for "ObfuscatedEntity".
 * Note that this is a low-level class: usually you should stick to the Box class.
 */
public final class ObfuscatedEntityCursor extends Cursor<ObfuscatedEntity> {
    @Internal
    static final class Factory implements CursorFactory<ObfuscatedEntity> {
        public Cursor<ObfuscatedEntity> createCursor(Transaction tx, long cursorHandle, BoxStore boxStoreForEntities) {
            return new ObfuscatedEntityCursor(tx, cursorHandle, boxStoreForEntities);
        }
    }

    private static final ObfuscatedEntity_.ObfuscatedEntityIdGetter ID_GETTER = ObfuscatedEntity_.__ID_GETTER;


    private final static int __ID_myInt = ObfuscatedEntity_.myInt.id;
    private final static int __ID_myString = ObfuscatedEntity_.myString.id;

    public ObfuscatedEntityCursor(Transaction tx, long cursor, BoxStore boxStore) {
        super(tx, cursor, ObfuscatedEntity_.__INSTANCE, boxStore);
    }

    @Override
    public long getId(ObfuscatedEntity entity) {
        return ID_GETTER.getId(entity);
    }

    /**
     * Puts an object into its box.
     *
     * @return The ID of the object within its box.
     */
    @Override
    public long put(ObfuscatedEntity entity) {
        String myString = entity.getMyString();
        int __id2 = myString != null ? __ID_myString : 0;

        long __assignedId = collect313311(cursor, entity.getId(), PUT_FLAG_FIRST | PUT_FLAG_COMPLETE,
                __id2, myString, 0, null,
                0, null, 0, null,
                __ID_myInt, entity.getMyInt(), 0, 0,
                0, 0, 0, 0,
                0, 0, 0, 0,
                0, 0, 0, 0);

        entity.setId(__assignedId);
        return __assignedId;
    }


}
